package com.foreverwin.mesnac.meapi.controller;

import com.foreverwin.modular.core.util.R;
import com.foreverwin.modular.core.util.FrontPage;
import com.foreverwin.modular.core.util.CommonMethods;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.foreverwin.mesnac.meapi.service.MessageTypeUserGroupService;
import com.foreverwin.mesnac.meapi.model.MessageTypeUserGroup;
import java.util.List;

/**
 *
 * @author Philip
 * @since 2021-08-07
 */
@RestController
@RequestMapping("/MESSAGE-TYPE-USER-GROUP")
public class MessageTypeUserGroupController {

    @Autowired
    public MessageTypeUserGroupService messageTypeUserGroupService;

    /**
    * 根据id查询
    *
    * @param id 主键
    * @return
    */
    @ResponseBody
    @GetMapping("/{id:.+}")
    public R getMessageTypeUserGroupById(@PathVariable String id) {
        return R.ok( messageTypeUserGroupService.getById(id));
    }

    /**
     * 查询所有数据
     *
     * @return
     */
    @ResponseBody
    @GetMapping("")
    public R getMessageTypeUserGroupList(MessageTypeUserGroup messageTypeUserGroup){
        List<MessageTypeUserGroup> result;
        QueryWrapper<MessageTypeUserGroup> queryWrapper = new QueryWrapper<>();
        queryWrapper.setEntity(messageTypeUserGroup);
        result = messageTypeUserGroupService.list(queryWrapper);
        return R.ok(result);
    }

    /**
     * 分页查询数据
     *
     * @param frontPage  分页信息
     * @return
     */
    @ResponseBody
    @GetMapping("/page")
    public R page(FrontPage<MessageTypeUserGroup> frontPage, MessageTypeUserGroup messageTypeUserGroup){
        IPage result;
        QueryWrapper<MessageTypeUserGroup> queryWrapper = new QueryWrapper<>();
        queryWrapper.setEntity(messageTypeUserGroup);
        if (frontPage.getGlobalQuery() != null && !"".equals(frontPage.getGlobalQuery().trim())) {
            //TODO modify global query
            queryWrapper.lambda().and(wrapper -> wrapper
                .like(MessageTypeUserGroup::getHandle, frontPage.getGlobalQuery())
                .or().like(MessageTypeUserGroup::getMessageTypeBo, frontPage.getGlobalQuery())
                .or().like(MessageTypeUserGroup::getUserGroupBo, frontPage.getGlobalQuery())
    );
        }
        result = messageTypeUserGroupService.page(frontPage.getPagePlus(), queryWrapper);
        return R.ok(result);
    }

    /**
     * 新增
     * @param messageTypeUserGroup  传递的实体
     * @return  null 失败  实体成功
     */
    @PostMapping
    public R save(@RequestBody MessageTypeUserGroup messageTypeUserGroup) {
        return R.ok(messageTypeUserGroupService.save(messageTypeUserGroup));
    }

    /**
     * 修改
     * @param messageTypeUserGroup  传递的实体
     * @return  null 失败  实体成功
     */
    @PutMapping
    public R updateById(@RequestBody MessageTypeUserGroup messageTypeUserGroup) {
        return R.ok(messageTypeUserGroupService.updateById(messageTypeUserGroup));
    }

    /**
     * 根据id删除对象
     * @param id  实体ID
     * @return 0 失败  1 成功
     */
    @ResponseBody
    @RequestMapping(method = RequestMethod.DELETE, value = "/{id:.+}")
    public R removeById(@PathVariable("id") String id){
        return R.ok(messageTypeUserGroupService.removeById(id));
    }

    /**
     * 批量删除对象
     * @param ids 实体集合ID
     * @return  0 失败  1 成功
     */
    @ResponseBody
    @RequestMapping(method = RequestMethod.POST, value = "/delete-batch")
    public R removeByIds(List<String> ids){
        return R.ok(messageTypeUserGroupService.removeByIds(ids));
    }
}